
// PrintPDF.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "afxwinappex.h"
#include "afxdialogex.h"
#include "PrintPDF.h"
#include "MainFrm.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CPrintPDFApp

BEGIN_MESSAGE_MAP(CPrintPDFApp, CWinApp)
	ON_COMMAND(ID_FILE_PRINT, &CPrintPDFApp::OnFilePrint)
	ON_COMMAND(ID_APP_ABOUT,&CPrintPDFApp::OnAppAbout)
END_MESSAGE_MAP()


// CPrintPDFApp construction

CPrintPDFApp::CPrintPDFApp()
{
	// support Restart Manager
	m_dwRestartManagerSupportFlags = AFX_RESTART_MANAGER_SUPPORT_ALL_ASPECTS;
#ifdef _MANAGED
	// If the application is built using Common Language Runtime support (/clr):
	//     1) This additional setting is needed for Restart Manager support to work properly.
	//     2) In your project, you must add a reference to System.Windows.Forms in order to build.
	System::Windows::Forms::Application::SetUnhandledExceptionMode(System::Windows::Forms::UnhandledExceptionMode::ThrowException);
#endif

	// TODO: replace application ID string below with unique ID string; recommended
	// format for string is CompanyName.ProductName.SubProduct.VersionInformation
	SetAppID(_T("PrintPDF.AppID.NoVersion"));

	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

// The one and only CPrintPDFApp object

CPrintPDFApp theApp;


void print_pdf()
{
	//Sleep(20000);

	PXC6::IPXCControlExPtr	pFactory6;

	try
	{
		CLSID clsid;
		if (SUCCEEDED(CLSIDFromProgID(L"PXCComLib6.CPXCControlEx",&clsid)))
			pFactory6 = PXC6::IPXCControlExPtr(__uuidof(PXC6::CPXCControlEx));
	}
	catch (_com_error &e)
	{
		CString str;
		str.Format(L"COM exception %d generated when creating PDF-XChange factory",e.Error());
		AfxMessageBox(str);

		return;
	}
	catch (...)
	{
		return;
	}

	PXC6::IPXCPrinterPtr pPrinter6;

	try
	{
		pPrinter6 = pFactory6->Printer[L"",
			L"PDF-XChange Standard V6",

			// Licence details hidden as requested by Tracker support
			L"",
			L""];
	}
	catch (_com_error &e)
	{
		CString str;
		str.Format(L"COM exception %d generated when creating PDF-XChange printer",e.Error());

		AfxMessageBox(str);

		pFactory6.Release();
		return;
	}
	catch (...)
	{
		AfxMessageBox(L"Exception generated when creating PDF-XChange 6 printer");
		pFactory6.Release();
		return;
	}

	pPrinter6->ResetDefaults();
	pPrinter6->Option[L"Save.SaveType"] = L"Save";
	pPrinter6->Option[L"Save.ShowSaveDialog"] = L"No";

	TCHAR filespec[100];
	time_t now_time_t = time(0);
	tm now_tm;
	localtime_s(&now_tm,&now_time_t);
	wcsftime(filespec,sizeof(filespec),TEXT("E:\\TEMP\\PrintPDF-%Y%m%d_%H%M%S"),&now_tm);

	pPrinter6->Option[L"Save.File"] = filespec;// L"E:\\Temp\\PrintPDF.PDF";

	pPrinter6->Option[L"Save.WhenExists"] = L"Overwrite";
	pPrinter6->Option[L"Save.RunApp"] = FALSE;
	pPrinter6->Option[L"Overlay.Enabled"] = FALSE;
	pPrinter6->Option[L"Compression.Graphics"] = TRUE;
	pPrinter6->Option[L"Compression.Text"] = TRUE;
	pPrinter6->Option[L"Fonts.EmbedAll"] = FALSE;
	pPrinter6->Option[L"Saver.ShowProgress"] = FALSE;

	pPrinter6->ApplyOptions(0);

	HDC hDC;

	// Create the HDC for the printer
	if ((hDC = CreateDC(TEXT("WINSPOOL"),pPrinter6->GetName(),NULL,NULL)) != NULL)
	{
		// The StartDoc function starts the print job
		DOCINFO di = {sizeof(DOCINFO)};
		di.lpszDocName = TEXT("Print Job");

		if (StartDoc(hDC,&di) > 0)
		{
			// The StartPage function prepares the printer driver to accept data
			if (StartPage(hDC) > 0)
			{
				TCHAR szString[100] = {};

				wcsftime(szString,sizeof(filespec),TEXT("Printing from a service %d/%m/%Y %H:%M:%S"),&now_tm);
				TextOut(hDC,0,0,szString,lstrlen(szString));

				EndPage(hDC);
			}

			EndDoc(hDC);
		}

		//  Delete the HDC
		DeleteDC(hDC);
	}

	if (pPrinter6)
		pPrinter6.Release();

	if (pFactory6)
		pFactory6.Release();
}

// CPrintPDFApp initialization

BOOL CPrintPDFApp::InitInstance()
{
	// InitCommonControlsEx() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	INITCOMMONCONTROLSEX InitCtrls;
	InitCtrls.dwSize = sizeof(InitCtrls);
	// Set this to include all the common control classes you want to use
	// in your application.
	InitCtrls.dwICC = ICC_WIN95_CLASSES;
	InitCommonControlsEx(&InitCtrls);

	CWinApp::InitInstance();


	// Initialize OLE libraries
	if (!AfxOleInit())
	{
		AfxMessageBox(IDP_OLE_INIT_FAILED);
		return FALSE;
	}

	AfxEnableControlContainer();

	EnableTaskbarInteraction(FALSE);

	// AfxInitRichEdit2() is required to use RichEdit control	
	// AfxInitRichEdit2();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	print_pdf();


	//// To create the main window, this code creates a new frame window
	//// object and then sets it as the application's main window object
	//CMainFrame* pFrame = new CMainFrame;
	//if (!pFrame)
	//	return FALSE;
	//m_pMainWnd = pFrame;
	//// create and load the frame with its resources
	//pFrame->LoadFrame(IDR_MAINFRAME,
	//	WS_OVERLAPPEDWINDOW | FWS_ADDTOTITLE, NULL,
	//	NULL);





	//// The one and only window has been initialized, so show and update it
	//pFrame->ShowWindow(SW_SHOW);
	//pFrame->UpdateWindow();
	return TRUE;
}

int CPrintPDFApp::ExitInstance()
{
	//TODO: handle additional resources you may have added
	AfxOleTerm(FALSE);

	return CWinApp::ExitInstance();
}

// CPrintPDFApp message handlers


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialog Data
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_ABOUTBOX };
#endif

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(IDD_ABOUTBOX)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()

// App command to run the dialog
void CPrintPDFApp::OnFilePrint()
{
	print_pdf();
}

// App command to run the dialog
void CPrintPDFApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

// CPrintPDFApp message handlers



